%% PREVIEW CONTROL DEMO
% Benjamin Stephens - 2009
% Robotics Institute, Carnegie Mellon University

clear all;clc
% close all;
figure(1);clf;
%%

T = 0.025;  % timestep
Tstep = 0.3;
Tdsp = 0.1;

xr0 = 0;
yr0 = -0.12;

xl0 = 0;
yl0 = 0.12;

x0 = [0,0.3,0]';
y0 = [0,0.0,0]';

xf0 = xr0;
yf0 = yr0;
xs0 = xl0;
ys0 = yl0; 

TRAJ = [x0(1),y0(1),x0( 2),y0(2)];

for i=1:10

preview_threestep_opt;

%%


j = Nstep+Ndsp+1;
% j = length(px);

x0 = [px(j),vx(j),0]';
y0 = [py(j),vy(j),0]';

plot(x0(1),y0(1),'kx','LineWidth',3);

traj = [px,py,vx,vy];

% if abs(x0(1) - 0.5*(xs0+xf0) + L/9.81*x0(2))<0.05 && abs(y0(1) - 0.5*(ys0+yf0) + L/9.81*y0(2))<0.05
%     TRAJ = [TRAJ;traj];
%     break;
% else
    TRAJ = [TRAJ;traj(1:j,:)];
% end


figure(1);

plot(traj(1:j,1),traj(1:j,2),'g-','LineWidth',2); hold on;
% plot(zx,zy,'b--','LineWidth',2);
% plot(zxref,zyref,'k--');
% plot(xf0,yf0,'m*');
% plot(xf,yf,'m*');
% plot([xf0;xf0+0.2*(x0(1)-xf0+x0(2)*sqrt(L/g))],[yf0;yf0+0.2*(y0(1)-yf0+y0(2)*sqrt(L/g))],'m-'); 
% 
h = plot([xs0-dx,xs0+dx,xs0+dx,xs0-dx,xs0-dx]',[ys0-dy,ys0-dy,ys0+dy,ys0+dy,ys0-dy]','k-',...
         [xf0-dx,xf0+dx,xf0+dx,xf0-dx,xf0-dx]',[yf0-dy,yf0-dy,yf0+dy,yf0+dy,yf0-dy]','b-');
     
% legend('com','zmp','xf0','xf1');     
     
% plot(xf(2),yf(2),'m*','LineWidth',3);

h = plot([xf(1)-dx,xf(1)+dx,xf(1)+dx,xf(1)-dx,xf(1)-dx]',[yf(1)-dy,yf(1)-dy,yf(1)+dy,yf(1)+dy,yf(1)-dy]','r-');     
% h =
% plot([xf(2)-dx,xf(2)+dx,xf(2)+dx,xf(2)-dx,xf(2)-dx]',[yf(2)-dy,yf(2)-dy,y
% f(2)+dy,yf(2)+dy,yf(2)-dy]','r--');    


axis equal;

xs0 = xf0;
ys0 = yf0;
xf0 = xf(1);
yf0 = yf(1);

end

% X = [x0;xf0;y0;yf0;xs0;ys0];
% [cost,step,traj] = preview_mex(X,1.0,T,1.0/T,Tstep,Tdsp);
% px=traj(1,:);
% py=traj(2,:);
% vx=traj(3,:);
% vy=traj(4,:);
% zx = px - 1.0/9.81*traj(5,:);
% zy = py - 1.0/9.81*traj(6,:);
% xf = step(1);
% yf = step(2);
% 
% j = Nstep+Ndsp+1;
% traj = [px',py',vx',vy'];
% TRAJ = [TRAJ;traj(1:j,:)];

% plot(px,py,'g--','LineWidth',2); hold on;
% plot(zx,zy,'b:','LineWidth',1);
% plot(xf0,yf0,'m*');
% plot(xf,yf,'m*');
% plot(0.5*(xf0+xf),0.5*(yf0+yf),'m*','LineWidth',3,'MarkerSize',8);
% h = plot([xf0-dx,xf0+dx,xf0+dx,xf0-dx,xf0-dx]',[yf0-dy,yf0-dy,yf0+dy,yf0+dy,yf0-dy]','b--',...
%          [xs0-dx,xs0+dx,xs0+dx,xs0-dx,xs0-dx]',[ys0-dy,ys0-dy,ys0+dy,ys0+dy,ys0-dy]','k-');   
% h = plot([xf-dx,xf+dx,xf+dx,xf-dx,xf-dx]',[yf-dy,yf-dy,yf+dy,yf+dy,yf-dy]','b--');
% axis equal;

figure(2);clf;
% subplot 211
plot(TRAJ(:,1:2));
% subplot 212
% plot(TRAJ(:,3:4));
